//
//		==================
//		Onstatement Module
//		==================

//	Author:		David Fuller
//			Bike Odyssey Pty Ltd
//			djf01@ozemail.com.au

//	Program to implement an OnStatement() callback function in PHP.


/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef ONSTATEMENT_H
#define ONSTATEMENT_H

// #define ZEND_EXT_API vs PHP_DBGR_API  -- what is the new PHP_WIN32

#ifdef PHP_WIN32
#define ZEND_EXT_API __declspec(dllexport)
#else
#define ZEND_EXT_API
#endif

ZEND_EXT_API	void onActivate();
ZEND_EXT_API	void onDeactivate();
ZEND_EXT_API	void onStatement(zend_op_array *op_array);
ZEND_EXT_API	void onFCallBegin(zend_op_array *op_array); 
ZEND_EXT_API	void onFCallEnd(zend_op_array *op_array); 

extern zend_module_entry onstatement_module_entry;
#define phpext_onstatement_ptr &onstatement_module_entry



ZEND_FUNCTION(onstatement_active);
ZEND_FUNCTION(onstatement_deactivate);

#ifdef PHP_WIN32
#define PHP_ONSTATEMENT_API __declspec(dllexport)
#else
#define PHP_ONSTATEMENT_API
#endif

PHP_MINIT_FUNCTION(onstatement);
PHP_MSHUTDOWN_FUNCTION(onstatement);
PHP_RINIT_FUNCTION(onstatement);
PHP_RSHUTDOWN_FUNCTION(onstatement);
PHP_MINFO_FUNCTION(onstatement);

PHP_FUNCTION(confirm_onstatement_compiled);	/* For testing, remove later. */




//	Thread Saftey ----
typedef struct 
{
	int fActiveted;
} php_onstatement_globals ;

//	Every function that needs to use variables in the above 
//	struct must call ONSTATEMENTLS_FETCH(); after declaring
//	other vars & refering to them using ONSTATEMENTG(varname);

#ifdef ZTS
#define ONSTATEMENTG(v)  (extname_globals->v)
#define ONSTATEMENTLS_FETCH()  php_onstatement_globals *onstatement_globals = 
ts_resource(gd_extname_id)
#else
#define ONSTATEMENTG(v)	 (extname_globals.v)
#define ONSTATEMENTLS_FETCH()
#endif


#endif 
